Index: trunk/sources/HeuristicLab.Hive.Server.Console/3.2/HeuristicLab.Hive.Server.Console-3.2.csproj
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Console/3.2/HeuristicLab.Hive.Server.Console-3.2.csproj	(revision 2064)
+++ trunk/sources/HeuristicLab.Hive.Server.Console/3.2/HeuristicLab.Hive.Server.Console-3.2.csproj	(revision 2065)
@@ -122,4 +122,10 @@
     </Compile>
     <Compile Include="HiveServerConsolePlugin.cs" />
+    <Compile Include="LogonDlg.cs">
+      <SubType>Form</SubType>
+    </Compile>
+    <Compile Include="LogonDlg.Designer.cs">
+      <DependentUpon>LogonDlg.cs</DependentUpon>
+    </Compile>
     <Compile Include="Properties\AssemblyInfo.cs" />
     <EmbeddedResource Include="AddGroup.resx">
@@ -140,4 +146,7 @@
       <DependentUpon>HiveServerManagementConsole.cs</DependentUpon>
       <SubType>Designer</SubType>
+    </EmbeddedResource>
+    <EmbeddedResource Include="LogonDlg.resx">
+      <DependentUpon>LogonDlg.cs</DependentUpon>
     </EmbeddedResource>
     <EmbeddedResource Include="Properties\Resources.resx">
Index: trunk/sources/HeuristicLab.Hive.Server.Console/3.2/HiveServerConsole.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Console/3.2/HiveServerConsole.Designer.cs	(revision 2064)
+++ trunk/sources/HeuristicLab.Hive.Server.Console/3.2/HiveServerConsole.Designer.cs	(revision 2065)
@@ -45,4 +45,5 @@
     /// </summary>
     private void InitializeComponent() {
+      System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(HiveServerConsole));
       this.gbConfiguration = new System.Windows.Forms.GroupBox();
       this.lblPort = new System.Windows.Forms.Label();
@@ -57,6 +58,9 @@
       this.tbPwd = new System.Windows.Forms.TextBox();
       this.lblError = new System.Windows.Forms.Label();
+      this.pictureBox1 = new System.Windows.Forms.PictureBox();
+      this.btnCancel = new System.Windows.Forms.Button();
       this.gbConfiguration.SuspendLayout();
       this.gpUser.SuspendLayout();
+      ((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).BeginInit();
       this.SuspendLayout();
       // 
@@ -67,5 +71,5 @@
       this.gbConfiguration.Controls.Add(this.tbPort);
       this.gbConfiguration.Controls.Add(this.tbIp);
-      this.gbConfiguration.Location = new System.Drawing.Point(12, 100);
+      this.gbConfiguration.Location = new System.Drawing.Point(188, 100);
       this.gbConfiguration.Name = "gbConfiguration";
       this.gbConfiguration.Size = new System.Drawing.Size(283, 82);
@@ -110,5 +114,5 @@
       // btnLogin
       // 
-      this.btnLogin.Location = new System.Drawing.Point(179, 188);
+      this.btnLogin.Location = new System.Drawing.Point(355, 193);
       this.btnLogin.Name = "btnLogin";
       this.btnLogin.Size = new System.Drawing.Size(116, 23);
@@ -125,5 +129,5 @@
       this.gpUser.Controls.Add(this.lblUsername);
       this.gpUser.Controls.Add(this.tbPwd);
-      this.gpUser.Location = new System.Drawing.Point(12, 12);
+      this.gpUser.Location = new System.Drawing.Point(188, 12);
       this.gpUser.Name = "gpUser";
       this.gpUser.Size = new System.Drawing.Size(283, 82);
@@ -171,9 +175,30 @@
       this.lblError.AutoSize = true;
       this.lblError.ForeColor = System.Drawing.Color.Red;
-      this.lblError.Location = new System.Drawing.Point(16, 238);
+      this.lblError.Location = new System.Drawing.Point(12, 193);
       this.lblError.Name = "lblError";
       this.lblError.Size = new System.Drawing.Size(0, 13);
       this.lblError.TabIndex = 5;
       // 
+      // pictureBox1
+      // 
+      this.pictureBox1.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox1.Image")));
+      this.pictureBox1.Location = new System.Drawing.Point(12, 12);
+      this.pictureBox1.Name = "pictureBox1";
+      this.pictureBox1.Size = new System.Drawing.Size(170, 170);
+      this.pictureBox1.SizeMode = System.Windows.Forms.PictureBoxSizeMode.Zoom;
+      this.pictureBox1.TabIndex = 8;
+      this.pictureBox1.TabStop = false;
+      // 
+      // btnCancel
+      // 
+      this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
+      this.btnCancel.Location = new System.Drawing.Point(259, 193);
+      this.btnCancel.Name = "btnCancel";
+      this.btnCancel.Size = new System.Drawing.Size(90, 23);
+      this.btnCancel.TabIndex = 9;
+      this.btnCancel.Text = "&Cancel";
+      this.btnCancel.UseVisualStyleBackColor = true;
+      this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
+      // 
       // HiveServerConsole
       // 
@@ -181,11 +206,17 @@
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.ClientSize = new System.Drawing.Size(311, 225);
+      this.BackColor = System.Drawing.Color.White;
+      this.CancelButton = this.btnCancel;
+      this.ClientSize = new System.Drawing.Size(482, 226);
+      this.Controls.Add(this.btnCancel);
+      this.Controls.Add(this.pictureBox1);
       this.Controls.Add(this.lblError);
       this.Controls.Add(this.gpUser);
       this.Controls.Add(this.btnLogin);
       this.Controls.Add(this.gbConfiguration);
+      this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
       this.Name = "HiveServerConsole";
-      this.Text = "Server Console";
+      this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
+      this.Text = "Server Console Logon";
       this.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.HiveServerConsole_KeyPress);
       this.gbConfiguration.ResumeLayout(false);
@@ -193,4 +224,5 @@
       this.gpUser.ResumeLayout(false);
       this.gpUser.PerformLayout();
+      ((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).EndInit();
       this.ResumeLayout(false);
       this.PerformLayout();
@@ -212,4 +244,6 @@
     private System.Windows.Forms.TextBox tbPwd;
     private System.Windows.Forms.Label lblError;
+    private System.Windows.Forms.PictureBox pictureBox1;
+    private System.Windows.Forms.Button btnCancel;
   }
 }
Index: trunk/sources/HeuristicLab.Hive.Server.Console/3.2/HiveServerConsole.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Console/3.2/HiveServerConsole.cs	(revision 2064)
+++ trunk/sources/HeuristicLab.Hive.Server.Console/3.2/HiveServerConsole.cs	(revision 2065)
@@ -33,4 +33,5 @@
 using System.Security.Cryptography;
 using System.Net;
+using System.Threading;
 
 namespace HeuristicLab.Hive.Server.ServerConsole {
@@ -42,8 +43,10 @@
     public HiveServerConsole() {
       InitializeComponent();
+#if(DEBUG)
       tbIp.Text = "10.20.53.1";
       tbPort.Text = WcfSettings.GetDefaultPort().ToString();
       tbUserName.Text = "test45";
       tbPwd.Text = "test";
+#endif
     }
 
@@ -70,7 +73,5 @@
         information.closeFormEvent += new closeForm(EnableForm);
         information.Show();
-      } else {
-        lblError.Text = "Problem with login";
-      }
+      } 
     }
 
@@ -81,40 +82,71 @@
     /// <returns></returns>
     private bool IsValid() {
-      if ((tbUserName.Text != "") &&
-          (tbPwd.Text != "") &&
-          (tbIp.Text != "") &&
-          (tbPort.Text != "")) {
+      Thread t = new Thread(new ThreadStart(ShowWaitDlg));
+      if (IsFormValidated()) {
+        IPAddress ipAdress = IPAddress.Parse(tbIp.Text);
+        int port = int.Parse(tbPort.Text);
+        IServerConsoleFacade scf = ServiceLocator.GetServerConsoleFacade();
         try {
-          IPAddress ipAdress;
-          int port;
-          if ((IPAddress.TryParse(tbIp.Text, out ipAdress)) &&
-            int.TryParse(tbPort.Text, out port)) {
-            IServerConsoleFacade scf = ServiceLocator.GetServerConsoleFacade();
-            Response resp = scf.Login(tbUserName.Text, tbPwd.Text);
-            string str = resp.StatusMessage;
-            if (resp.StatusMessage != "Logged in") {
-              return false;
-            }
-          } else {
-            lblError.Text = "IP or Port not valid";
-          }
+          lblError.Text = "Trying to logon...";
+          t.Start();
+          Response resp = scf.Login(tbUserName.Text, tbPwd.Text);
+          t.Abort();
+          if (resp.StatusMessage == "Logged in") return true;
+          lblError.Text = resp.StatusMessage;
         }
         catch (Exception ex) {
-          lblError.Text = "Server not online";
+          //login failed
+          lblError.Text = "Logon failed!";
+          t.Abort();
           return false;
         }
-        return true;
-      } else {
-        if (tbUserName.Text == "") {
-          lblError.Text = "Please type in Username";
-        } else if (tbPwd.Text == "") {
-          lblError.Text = "Please type in Password";
-        } else if (tbPort.Text == "") {
-          lblError.Text = "Please type in Port";
-        } else if (tbIp.Text == "") {
-          lblError.Text = "Please type in IP-Adress";
-        }
-        return false;
       }
+      //validation failed
+      t.Abort();
+      return false;
+    }
+
+    private void ShowWaitDlg() {
+      LogonDlg dlg = new LogonDlg();
+      dlg.ShowDialog();
+    }
+
+    /// <summary>
+    /// Validates the form.
+    /// </summary>
+    /// <returns></returns>
+    private bool IsFormValidated() {
+      bool isValid = true;
+      if (String.IsNullOrEmpty(tbUserName.Text)) {
+        lblError.Text = "Please type in Username.";
+        isValid = false;
+      }
+      if (String.IsNullOrEmpty(tbPwd.Text)) {
+        lblError.Text = "Please type in Password.";
+        isValid = false;
+      }
+      if (String.IsNullOrEmpty(tbIp.Text)) {
+        lblError.Text = "Please type in Port.";
+        isValid = false;
+      }
+      if (String.IsNullOrEmpty(tbPort.Text)) {
+        lblError.Text = "Please type in IP-Address.";
+        isValid = false;
+      }
+      try {
+        int.Parse(tbPort.Text);
+      }
+      catch (Exception ex) {
+        isValid = false;
+        lblError.Text = "Please verify entered Port.";
+      }
+      try {
+        IPAddress.Parse(tbIp.Text);
+      }
+      catch (Exception ex) {
+        isValid = false;
+        lblError.Text = "Please verify entered IP address.";
+      }
+      return isValid;
     }
 
@@ -124,5 +156,5 @@
         ServiceLocator.ShutDownFacade();
         if (error == true) {
-          lblError.Text = "Something went wrong with the server";
+          lblError.Text = "Establishing server connection failed.";
         }
       }
@@ -134,4 +166,8 @@
       }
     }
+
+    private void btnCancel_Click(object sender, EventArgs e) {
+      Dispose();
+    }
   }
 }
Index: trunk/sources/HeuristicLab.Hive.Server.Console/3.2/LogonDlg.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Console/3.2/LogonDlg.Designer.cs	(revision 2065)
+++ trunk/sources/HeuristicLab.Hive.Server.Console/3.2/LogonDlg.Designer.cs	(revision 2065)
@@ -0,0 +1,76 @@
+﻿namespace HeuristicLab.Hive.Server.ServerConsole {
+  partial class LogonDlg {
+    /// <summary>
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary>
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Windows Form Designer generated code
+
+    /// <summary>
+    /// Required method for Designer support - do not modify
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(LogonDlg));
+      this.pictureBox1 = new System.Windows.Forms.PictureBox();
+      this.label1 = new System.Windows.Forms.Label();
+      ((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).BeginInit();
+      this.SuspendLayout();
+      // 
+      // pictureBox1
+      // 
+      this.pictureBox1.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox1.Image")));
+      this.pictureBox1.Location = new System.Drawing.Point(12, 12);
+      this.pictureBox1.Name = "pictureBox1";
+      this.pictureBox1.Size = new System.Drawing.Size(97, 77);
+      this.pictureBox1.SizeMode = System.Windows.Forms.PictureBoxSizeMode.CenterImage;
+      this.pictureBox1.TabIndex = 0;
+      this.pictureBox1.TabStop = false;
+      // 
+      // label1
+      // 
+      this.label1.AutoSize = true;
+      this.label1.Font = new System.Drawing.Font("Segoe UI", 14.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
+      this.label1.ForeColor = System.Drawing.Color.White;
+      this.label1.Location = new System.Drawing.Point(115, 37);
+      this.label1.Name = "label1";
+      this.label1.Size = new System.Drawing.Size(276, 25);
+      this.label1.TabIndex = 1;
+      this.label1.Text = "Connecting... Please stand by.";
+      // 
+      // LogonDlg
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.BackColor = System.Drawing.Color.RoyalBlue;
+      this.ClientSize = new System.Drawing.Size(450, 101);
+      this.Controls.Add(this.label1);
+      this.Controls.Add(this.pictureBox1);
+      this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None;
+      this.Name = "LogonDlg";
+      this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
+      this.Text = "LogonDlg";
+      ((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).EndInit();
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.PictureBox pictureBox1;
+    private System.Windows.Forms.Label label1;
+  }
+}
Index: trunk/sources/HeuristicLab.Hive.Server.Console/3.2/LogonDlg.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Console/3.2/LogonDlg.cs	(revision 2065)
+++ trunk/sources/HeuristicLab.Hive.Server.Console/3.2/LogonDlg.cs	(revision 2065)
@@ -0,0 +1,16 @@
+﻿using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Data;
+using System.Drawing;
+using System.Linq;
+using System.Text;
+using System.Windows.Forms;
+
+namespace HeuristicLab.Hive.Server.ServerConsole {
+  public partial class LogonDlg : Form {
+    public LogonDlg() {
+      InitializeComponent();
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Hive.Server.Core/3.2/Authorization/HivePermissionManager.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Core/3.2/Authorization/HivePermissionManager.cs	(revision 2065)
+++ trunk/sources/HeuristicLab.Hive.Server.Core/3.2/Authorization/HivePermissionManager.cs	(revision 2065)
@@ -0,0 +1,87 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Security.Contracts.Interfaces;
+using HeuristicLab.DataAccess;
+using HeuristicLab.Security.Contracts.BusinessObjects;
+using HeuristicLab.Hive.Contracts.BusinessObjects;
+using HeuristicLab.Hive.Contracts.Interfaces;
+using HeuristicLab.Hive.Contracts;
+using HeuristicLab.Hive.Server.Core.InternalInterfaces;
+using System.ServiceModel;
+
+namespace HeuristicLab.Hive.Server.Core {
+  public class HivePermissionManager : IHivePermissionManager {
+
+    private IJobManager jobManager = ServiceLocator.GetJobManager();
+    
+    private IPermissionManager permManager = ServiceLocator.GetPermissionManager();
+
+    private IClientManager clientManager = ServiceLocator.GetClientManager();
+
+    private PermissionCollection permissions = HivePermissions.GetPermissions();
+    private PolicyCollection policyCollection = HivePermissions.GetPolicies();
+
+    /// <summary>
+    /// Authenticates an user and returns a valid guid if success.
+    /// </summary>
+    /// <param name="username"></param>
+    /// <param name="password"></param>
+    /// <returns></returns>
+    public Guid Login(string username, string password) {
+      return permManager.Authenticate(username, password);
+    }
+
+    /// <summary>
+    /// Checks user permission against predefined policy.
+    /// </summary>
+    /// <param name="policyName">Policy Name defines the action.</param>
+    /// <param name="sessionID">Session ID identifies a currently logged on user.</param>
+    /// <param name="entityID">Entity ID can be some resource or emtpy.</param>
+    public void Authorize(string policyName, Guid sessionID, Guid entityID) {
+      //check if this policy has a permission with 'ANY' scope defined
+      Permission p = policyCollection[policyName].GetPermissionByContext("Any");
+      
+      //check if user has 'xxx.Any' permission
+      if (p != null)
+        if (CheckPermission(sessionID, p.Id, entityID)) return;
+      
+      //check if this policy has a permission with 'PROJECT' scope defined
+      p = policyCollection[policyName].GetPermissionByContext("Project");
+      //check if user has 'xxx.Project' permission
+      if (p != null)
+        if (CheckPermission(sessionID, p.Id, jobManager.GetJobById(entityID).Obj.Project.Id)) return;
+
+      //check if this policy has a permission with 'OWNER' scope defined
+      p = policyCollection[policyName].GetPermissionByContext("User");
+      //check if user has 'xxx.Owner' permission
+      if (p != null)
+        if (CheckPermission(sessionID, p.Id, jobManager.GetJobById(entityID).Obj.UserId)) return;
+      //throw an exception when user access fails
+      throw new PermissionException(policyName);
+    }
+
+    /// <summary>
+    /// Checks if a user has permission for a specified action.
+    /// </summary>
+    /// <param name="sessionID">The current session.</param>
+    /// <param name="actionID">A pre-defined action that requires permission.</param>
+    /// <param name="entityID">A resource (Job,...)</param>
+    /// <returns></returns>
+    public bool CheckPermission(Guid sessionID, Guid actionID, Guid entityId) {
+      bool hasPerm = permManager.CheckPermission(sessionID, actionID, entityId);
+      PermissionCollection pc = HivePermissions.GetPermissions();
+      if (!hasPerm)
+          if (CheckPermissionHelper(sessionID, actionID, entityId)) return true;
+      return hasPerm;
+    }
+
+    private bool CheckPermissionHelper(Guid sessionId, Guid actionId, Guid entityId) {
+      IList<ClientGroup> groups = clientManager.GetAllGroupsOfResource(entityId).Obj;
+      foreach (ClientGroup group in groups)
+        if (CheckPermission(sessionId, actionId, group.Id)) return true;
+      return false;
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Hive.Server.Core/3.2/Authorization/HivePermissionSet.xsd
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Core/3.2/Authorization/HivePermissionSet.xsd	(revision 2065)
+++ trunk/sources/HeuristicLab.Hive.Server.Core/3.2/Authorization/HivePermissionSet.xsd	(revision 2065)
@@ -0,0 +1,19 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<xs:schema attributeFormDefault="unqualified" elementFormDefault="qualified" xmlns:xs="http://www.w3.org/2001/XMLSchema">
+  <xs:element name="Permissions">
+    <xs:complexType>
+      <xs:sequence>
+        <xs:element maxOccurs="unbounded" name="Permission">
+          <xs:complexType>
+            <xs:sequence>
+              <xs:element name="ID" type="xs:string" />
+              <xs:element name="Description" type="xs:string" />
+              <xs:element name="Plugin" type="xs:string" />
+            </xs:sequence>
+            <xs:attribute name="name" type="xs:string" use="required" />
+          </xs:complexType>
+        </xs:element>
+      </xs:sequence>
+    </xs:complexType>
+  </xs:element>
+</xs:schema>
Index: trunk/sources/HeuristicLab.Hive.Server.Core/3.2/Authorization/HivePermissions.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Core/3.2/Authorization/HivePermissions.cs	(revision 2065)
+++ trunk/sources/HeuristicLab.Hive.Server.Core/3.2/Authorization/HivePermissions.cs	(revision 2065)
@@ -0,0 +1,206 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Xml.XPath;
+using HeuristicLab.Security.Contracts.BusinessObjects;
+using System.Diagnostics;
+
+namespace HeuristicLab.Hive.Server.Core  {
+  
+  public static class HivePermissions {
+    private const string PERMISSIONFILE = "Authorization//HivePermissionSet.xml";
+    private const string POLICIESFILE = "Authorization//HivePermissionPolicy.xml";
+
+    public static class Jobmanagement {
+      [Flags]
+      public enum Assign {
+        ToAnyResource = 0x02,
+        ToProject = 0x04
+      }
+      [Flags]
+      public enum Abort {
+        /// <summary>Can abort any job.</summary>
+        Any = 0x02,
+        /// <summary>Can abort jobs from specific project only.</summary>
+        ProjectOnly = 0x04,
+        /// <summary>Can abort only owned jobs.</summary>
+        OwnedOnly = 0x08
+      }
+      [Flags]
+      public enum Create {
+        /// <summary>Can create a job everywhere.</summary>
+        Any = 0x02,
+        /// <summary>Can create a job in project context only.</summary>
+        ProjectOnly = 0x04,
+        /// <summary>Can create a job for owned resources only.</summary>
+        OwnedOnly = 0x08
+      }
+      [Flags]
+      public enum Read {
+        /// <summary>Can read any job.</summary>
+        Any = 0x02,
+        /// <summary>Can read a job in project context only.</summary>
+        ProjectOnly = 0x04,
+        /// <summary>Can read only owned job.</summary>
+        OwnedOnly = 0x08
+      }
+      [Flags]
+      public enum Delete {
+        /// <summary>Can delete any job.</summary>
+        Any = 0x02,
+        /// <summary>Can delete a job in project context only.</summary>
+        ProjectOnly = 0x04,
+        /// <summary>Can delete only owned job.</summary>
+        OwnedOnly = 0x08
+      }
+    }
+
+    public static class Usermanagement {
+      [Flags]
+      public enum User {
+        Create = 0x02,
+        Read = 0x04,
+        Update = 0x08,
+        Delete = 0x16
+      }
+
+      [Flags]
+      public enum UserGroup {
+        Create = 0x02,
+        Read = 0x04,
+        Update = 0x08,
+        Delete = 0x16
+      }
+
+      [Flags]
+      public enum Client {
+        Create = 0x02,
+        Read = 0x04,
+        Update = 0x08,
+        Delete = 0x16
+      }
+
+      [Flags]
+      public enum ClientGroup {
+        Create = 0x02,
+        Read = 0x04,
+        Update = 0x08,
+        Delete = 0x16
+      }
+    }
+
+    public static class PermissionManagement {
+      [Flags]
+      public enum Permission {
+        Grant = 0x02,
+        Revoke = 0x04
+      }
+    }
+
+    public static class ResourceManagement {
+      [Flags]
+      public enum Project {
+        Create = 0x02,
+        Read = 0x04,
+        Update = 0x08,
+        Delete = 0x16
+      }
+    }
+
+    private static PermissionCollection pc;
+
+    private static PolicyCollection pol;
+
+    public static PermissionCollection GetPermissions() {
+      if (pc == null) {
+        pc = new PermissionCollection();
+        LoadFromXml(pc.Permissions, PERMISSIONFILE);
+      }
+      return pc;
+    }
+
+    public static PolicyCollection GetPolicies() {
+      if (pol == null) {
+        pol = new PolicyCollection();
+        LoadFromXml(pol.Policies, POLICIESFILE);
+      }
+      return pol;
+    }
+
+    public static string ConvertEnumType(object obj) {
+      string retVal = string.Empty;
+      Type t = obj.GetType();
+      string value = obj.ToString();
+      retVal = (t.FullName.Replace(t.Namespace + ".", "")).Replace("+", ".") + "." + value;
+      return retVal;
+    }
+
+    /// <summary>
+    /// Permission
+    /// </summary>
+    /// <param name="perm"></param>
+    private static void LoadFromXml(IList<Permission> perm, string filename) {
+      Permission p = null;
+      XPathDocument doc;
+      doc = new XPathDocument(filename);
+      XPathNavigator nav = doc.CreateNavigator();
+      nav.MoveToRoot();
+      do {
+        if (nav.NodeType == XPathNodeType.Element && nav.Name == "Permission") {
+          p = new Permission();
+          p.Name = nav.GetAttribute("name", "");
+          nav.MoveToFollowing(XPathNodeType.Element);
+          if (nav.Name == "ID")
+            p.Id = new Guid(nav.Value);
+          nav.MoveToFollowing(XPathNodeType.Element);
+          if (nav.Name == "Description")
+            p.Description = nav.Value;
+          nav.MoveToFollowing(XPathNodeType.Element);
+          if (nav.Name == "Plugin")
+            p.Plugin = nav.Value;
+          perm.Add(p);
+        }
+      } while (nav.MoveToFollowing(XPathNodeType.Element));
+    }
+
+    /// <summary>
+    /// Policy
+    /// </summary>
+    /// <param name="pol"></param>
+    /// <param name="filename"></param>
+    private static void LoadFromXml(IList<Policy> policyList, string filename) {
+      PermissionCollection permissionCollection = GetPermissions();
+      XPathDocument doc = new XPathDocument(filename);
+      XPathNavigator nav = doc.CreateNavigator();
+      nav.MoveToRoot();
+      //receive all policies -> Element <Policy name="xxx">...</Policy>
+      do {
+        if (nav.NodeType == XPathNodeType.Element && nav.Name == "Policy") {
+          string policyName = nav.GetAttribute("name", "");
+          Policy policy = new Policy(policyName);
+          nav.MoveToFollowing(XPathNodeType.Element);
+          //receive all permissions -> Element <Permission.../>
+          do {
+            if (nav.Name == "Permission" && nav.HasAttributes) {
+              PermissionContext ctx = new PermissionContext();
+              int prior = 0;
+              int.TryParse(nav.GetAttribute("priority", ""), out prior);
+              ctx.Priority = prior;
+              ctx.Elevation = nav.GetAttribute("context", "");
+              string permissionName = nav.GetAttribute("name", "");
+              if (!string.IsNullOrEmpty(permissionName)) {
+                Permission permission = permissionCollection[permissionName];
+                Debug.WriteLineIf(permission == null, "Permission '" + permissionName + "' not found in PermissionCollection!");
+                if (permission != null)
+                  policy.AddPermission(permission, ctx);
+              }
+            }
+          } while (nav.MoveToNext());
+          policyList.Add(policy);
+        }
+      } while (nav.MoveToFollowing(XPathNodeType.Element));
+    }
+  }
+  
+}
Index: trunk/sources/HeuristicLab.Hive.Server.Core/3.2/Authorization/PermissionCollection.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Core/3.2/Authorization/PermissionCollection.cs	(revision 2065)
+++ trunk/sources/HeuristicLab.Hive.Server.Core/3.2/Authorization/PermissionCollection.cs	(revision 2065)
@@ -0,0 +1,56 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Security.Contracts.BusinessObjects;
+
+namespace HeuristicLab.Hive.Server.Core {
+  public class PermissionCollection : IEnumerable<Permission> {
+    public IList<Permission> perm = new List<Permission>();
+
+    public PermissionCollection() {
+    }
+
+    public IList<Permission> Permissions {
+      get { return perm; }
+    }
+
+    /// <summary>
+    /// Gets the Permission identified by FQN type.
+    /// </summary>
+    /// <param name="permissionName">eg. 'HivePermissions.Jobmanagement.Create.Any'</param>
+    /// <returns></returns>
+    public Permission this[string permissionName] {
+      get {
+        foreach (Permission item in perm) {
+          if (item.Name == permissionName)
+            return item;
+        }
+        return null;
+      }
+    }
+
+    /// <summary>
+    /// Converts an enumeration to a fully qualified string.
+    /// </summary>
+    /// <param name="obj">Any enumeration type.</param>
+    /// <returns>Type Information in Full Qualified Notation (FQN).</returns>
+    public string Convert(object obj) {
+      string retVal = string.Empty;
+      Type t = obj.GetType();
+      string value = obj.ToString();
+      retVal = (t.FullName.Replace(t.Namespace + ".", "")).Replace("+", ".") + "." + value;
+      return retVal;
+    }
+
+    public IEnumerator<Permission> GetEnumerator() {
+      return perm.GetEnumerator();
+    }
+
+    System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator() {
+      return perm.GetEnumerator();
+    }
+
+  }
+
+}
Index: trunk/sources/HeuristicLab.Hive.Server.Core/3.2/Authorization/PermissionContext.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Core/3.2/Authorization/PermissionContext.cs	(revision 2065)
+++ trunk/sources/HeuristicLab.Hive.Server.Core/3.2/Authorization/PermissionContext.cs	(revision 2065)
@@ -0,0 +1,24 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+
+namespace HeuristicLab.Hive.Server.Core {
+  /// <summary>
+  /// Holds additional information about a certain permission.
+  /// </summary>
+  public class PermissionContext {
+    private int _priority;
+    /// <summary>
+    /// Gets or sets the priority of this permission rule.
+    /// </summary>
+    public int Priority { get { return this._priority; } set { this._priority = value; } }
+
+    private string _elevation;
+    /// <summary>
+    /// Gets or sets the Rights Elevation Information. (Primary Policy Context)
+    /// </summary>
+    public string Elevation { get { return this._elevation; } set { this._elevation = value; } }
+
+  }
+}
Index: trunk/sources/HeuristicLab.Hive.Server.Core/3.2/Authorization/PermissionException.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Core/3.2/Authorization/PermissionException.cs	(revision 2065)
+++ trunk/sources/HeuristicLab.Hive.Server.Core/3.2/Authorization/PermissionException.cs	(revision 2065)
@@ -0,0 +1,17 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.ServiceModel;
+
+namespace HeuristicLab.Hive.Server.Core {
+  public class PermissionException : FaultException {
+    public PermissionException()
+      : base("Current user has insufficent rights for this action!") {
+    }
+
+    public PermissionException(string msg)
+      : base("Current user has insufficent rights for this action: " + msg) {
+    }
+  }
+}
